﻿////////////////////////////////////////////////////////////////
// Classe TexteMath pour écrire des expressions Mathématiques //
// Développé à l'origine pour TracenPoche  tracenpoche.net    //
////////////////////////////////////////////////////////////////
// Nécessite la classe CarMath : affichage de caractères maths//
// ---------------------------------------------------------- //
// Réalisé par KEOPS - Libre GNU GPL - Juin 2006              //
////////////////////////////////////////////////////////////////
// 05/07/06 correction crochet et parenthèses
// changer style !
dynamic class TexteMath {
	//
	//  var textemath = new TexteMath(un_mc,"£f(1,)");
	//  textemath.ecriture();
	//             1
	//    donnera ---
	//             3
	//  textemath.detruitEcriture();
	//     pour détuire les objets internes avant un
	//  delete textemath;
	//
	private var le_mc:MovieClip;
	//clip parent d'accueil du rendu
	private var la_formule:String;
	//formule de l'écriture
	private var le_tableau:Array;
	//décomposition de la formule
	private var le_marqueur:String;
	//caractère marqueur: £ par défaut
	private var la_taille_police:Number;
	//12 par défaut
	private var le_carMath:CarMath;
	//affectations pour conversions
	public var texteToHTMLFonc:Function;
	//texteToHTMLFonc(chaine, taille, couleur, effet)->string
	public var la_couleur:Number;
	//pour texteToHTMLTexte
	public var le_style:Number;
	//pour texteToHTMLTexte : 50+-:taille+- +100:italic +200:gras +300:italique_gras
	//
	function TexteMath(mc:MovieClip, formule:String, marqueur:String, taille:Number, couleur:Number, style:Number, dessine:Boolean, texteToHTML:Function, carMath:CarMath) {
	// style, dessine, texteToHTML, traiteSymboles sont optionnels
		this.le_mc = mc;
		if (formule != undefined) {
			this.la_formule = formule;
		} else {
			this.la_formule = "";
		}
		this.le_tableau = new Array();
		if (marqueur != undefined) {
			this.le_marqueur = marqueur;
		} else {
			this.le_marqueur = "£";
		}
		if (taille != undefined) {
			this.la_taille_police = taille;
		} else {
			this.la_taille_police = 12;
		}
		if (couleur != undefined) {
			this.la_couleur = couleur;
		} else {
			this.la_couleur = 0;
		}
		if (style != undefined) {
			this.le_style = style;
		} else {
			this.le_style = 0;
		}
		if(texteToHTML != undefined) {
			this.texteToHTMLFonc = texteToHTML;
		} else {
			this.texteToHTMLFonc = texteToHTMLTexte;
		}
		if (carMath != undefined) {
			this.le_carMath = carMath;
		} else {
			this.le_carMath = new CarMath("", this.le_marqueur);
		}
		if (dessine == true) {
			if (this.formule != "") {
				this.prepareEcriture();
				if (this.le_mc != undefined) {
					this.dessineEcriture();
				}
			}
		}
	}
	//
	public function set formule(chaine:String) {
		this.la_formule = chaine;
	}
	//
	public function get formule() : String {
		return this.la_formule;
	}
	//
	public function set marqueur(chaine:String) {
		this.le_marqueur = chaine;
	}
	//
	public function get marqueur() : String {
		return this.le_marqueur;
	}
	//
	public function get tableau() : Array {
		return this.le_tableau;
	}
	//
	public function set taille_police(valeur:Number) {
		this.la_taille_police = valeur;
	}
	//
	public function get taille_police() : Number {
		return this.la_taille_police;
	}
	//
	public function set couleur(valeur:Number) {
		this.la_couleur = valeur;
	}
	//
	public function set style(valeur:Number) {
		this.le_style = valeur;
	}
	//
	public function prepareEcriture() {
		// on purge l'existant éventuel
		this.detruitEcriture();
		//magique : puissant !
		this.le_carMath.chaine=this.la_formule;
		//
		this.le_tableau = this.texteToTableauMef(this.le_carMath.chaine);
		prepareNiveaux(this.le_tableau, this.le_mc);
	}
	//
	public function dessineEcriture() {
		if (this.le_mc.hauteur != undefined) {
			dessineNiveaux(this.le_tableau, this.le_mc);
		}
	}
	//
	public function detruitEcriture() {
		if (this.le_tableau.length>0) {
			detruitTableau(this.le_tableau);
		}
		if (this.le_mc.hauteur != undefined) {
			detruitNiveaux(this.le_tableau, this.le_mc);
		}
	}
	//
	public function ecriture() {
		this.prepareEcriture();
		this.dessineEcriture();
	}
	//
	/////////////////////////////////////////////////////////////////////////
	// Utilitaires
	/////////////////////////////////////////////////////////////////////////
	//
	function texteToHTMLTexte(chaine : String, taille : Number, couleur : Number, effet : Number) : String {
		//effet:50+-:taille  +100:italic +200:gras +300:italic_gras
		var chainetexte : String;
		chainetexte = "<font color='#"+couleur.toString(16)+"' size='"+(taille+((effet%100)-50)*2)+"'>";
		if (effet%1000>300) {
			chainetexte = chainetexte+"<b><i>"+chaine+"</i></b>";
		} else {
			if (effet%1000>200) {
				chainetexte = chainetexte+"<b>"+chaine+"</b>";
			} else {
				if (effet%1000>100) {
					chainetexte = chainetexte+"<i>"+chaine+"</i>";
				} else {
					chainetexte = chainetexte+chaine;
				}
			}
		}
		chainetexte = chainetexte+"</font>";
		return chainetexte;
	}
	//
	//
	private function estdansliste(c : String, liste : Array) : Boolean {
		for (var i : Number = 0; i<=liste.length; i++) {
			if (c == liste[i]) {
				return true;
			}
		}
		return false;
	}
	//
	/////////////////////////////////////////////////////////////////////////
	// Gestion Tableau
	/////////////////////////////////////////////////////////////////////////
	//
	private function traceTableau(tab : Object) {
		var profondeur : Number = 3;
		var espace : String = "";
		var t : String = "";
		for (var i : Number = 0; i<profondeur; i++) {
			espace += " ";
		}
		for (var i : Number = 0; i<tab.length; i++) {
			t = ""+tab[i];
			if (t.length != tab[i].length) {
				traceTableau(tab[i], profondeur+2);
			} else {
				if (t == "") {
					t = "...";
				}
				trace(">"+espace+t);
			}
		}
	}
	//
	public function detruitTableau(tab : Object) {
		var t : String = "";
		for (var i : Number = 0; i<tab.length; i++) {
			t = ""+tab[i];
			if (t.length != tab[i].length) {
				detruitTableau(tab[i]);
				delete tab[i];
			}
		}
	}
	//
	private function compteNiveaux(tab : Object) : Number {
		var n : Number = 0;
		var t : String = "";
		for (var i : Number = 0; i<tab.length; i++) {
			t = ""+le_tableau[i];
			if (t.length != tab[i].length) {
				//trace(">>>"+tab[i]);
				if (tab[i][0].indexOf(this.le_marqueur) == 0) {
					if (tab[i][0].substr(1) == "f") {
						n = n+2;
					}
				}
				n = n+compteNiveaux(tab[i]);
			}
		}
		return n;
	}
	//
	private function trouveNextPFerme(chaine : String, posdeb : Number) : Number {
		var cpo : Number = 1;
		var ppos : Number = posdeb+1;
		var c : String= "";
		for (; (ppos<chaine.length) and (cpo != 0); ppos++) {
			c = chaine.charAt(ppos);
			switch (c) {
			case "(" :
				cpo++;
				break;
			case ")" :
				cpo--;
				break;
			}
		}
		if (cpo == 0) {
			return ppos;
		} else {
			return -1;
		}
	}
	//
	private function trouveVirgSep(chaine : String, posdeb : Number) : Number {
		var cpo : Number = 0;
		var ppos : Number = posdeb+1;
		var found : Boolean = false;
		var c : String = "";
		for (; (ppos<chaine.length) and !(found); ppos++) {
			c = chaine.charAt(ppos);
			switch (c) {
			case "(" :
				cpo++;
				break;
			case ")" :
				cpo--;
				break;
			case "," :
				found = (cpo == 0);
				break;
			}
		}
		if (cpo == 0) {
			return ppos;
		} else {
			return -1;
		}
	}
	//
	private function texteToTableauMef(chaine : String) : Array {
		var res : Array = new Array();
		var tab0 : String = "";
		var tab1 : String = chaine;
		var cpos : Number = tab1.indexOf(this.le_marqueur);
		var res1 : Array;
		var p2: Number =0;
		//trace("cpos init:"+cpos);
		while (cpos>=0) {
			tab0 = tab1.substr(0, cpos);
			//trace(">>"+tab0);
			res.push(tab0);
			tab1 = tab1.substr(cpos+1);
			//trace("??"+tab1);
			var op : Number = tab1.indexOf("(");
			var ope : String = tab1.substr(0, op);
			if (estdansliste(ope, ["a", "c", "e", "f", "i", "p", "r", "u", "v"])) {
				//trace("ope="+ope);
				if (ope == "f") {
					var p1 : Number = trouveVirgSep(tab1, op);
					p2 = trouveNextPFerme(tab1, op);
					var op1 : String = tab1.substring(op+1, p1-1);
					var op2 : String = tab1.substring(p1, p2-1);
					//trace("op1="+op1);
					//trace("op2="+op2);
					res1 = new Array();
					res1.push(le_marqueur+ope);
					res1.push(texteToTableauMef(op1));
					res1.push(texteToTableauMef(op2));
				} else {
					p2 = trouveNextPFerme(tab1, op);
					var op1 : String = tab1.substring(op+1, p2-1);
					//trace("op1="+op1);
					res1 = new Array();
					res1.push(le_marqueur+ope);
					res1.push(texteToTableauMef(op1));
				}
				//trace("res1="+res1);
				tab1 = tab1.substr(p2);
				res.push(res1);
			}
			cpos = tab1.indexOf(le_marqueur);
		}
		if (cpos<0) {
			//trace("0>"+tab1);
			res.push(tab1);
		}
		//trace("fin texteToMef");
		return res;
	}
	//
	/////////////////////////////////////////////////////////////////////////
	// Rendu graphique
	/////////////////////////////////////////////////////////////////////////
	//
	private function prepareNiveaux(tab : Array, parent : MovieClip) {
		if (this.le_mc == undefined) {
			trace("TexteMath : Erreur MovieClip parent non affecté !");
			trace("   new TexteMath(mc_parent,formule,...)");
			trace("...traitement interrompu.");
			return;
		}
		// hauteur globale du niveau
		parent.hauteur = 0;
		parent.posbas = 0;
		// taille de la police "réduite" pour exposant et indice
		parent.taille = this.la_taille_police;
		//
		var ok : Boolean = true;
		var t : String = "";
		for (var i : Number = 0; i<tab.length; i++) {
			// parent contient tout les clips modules : "enfant"+i
			// dans ce clip, on trouve un clip "enfant" qui contient
			// le clip (ou les clips pour fraction) où sont représentés
			// les sous modules
			// on pourra embellir dans le clip "enfant" :
			// dessin de la racine, trait de fraction, position des sous-modules ...
			//
			// détecte si on a un texte ou un tableau !
			t = ""+le_tableau[i];
			ok = (t.length != tab[i].length);
			if (ok) {
				//c'est un tableau,
				//détecte le marqueur en position 0
				ok = (tab[i][0].indexOf(this.le_marqueur) == 0);
				if (ok) {
					//marquer connu
					var c : String = tab[i][0].substr(1);
					switch (c) {
					case "f" :
						parent.createEmptyMovieClip("enfant"+i, i);
						parent["enfant"+i].createEmptyMovieClip("enfant", 0);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant0", 0);
						prepareNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant1", 1);
						prepareNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						break;
					case "a" :
					case "c" :
					case "e" :
					case "i" :
					case "p" :
					case "r" :
					case "u" :
					case "v" :
						parent.createEmptyMovieClip("enfant"+i, i);
						parent["enfant"+i].createEmptyMovieClip("enfant", 0);
						parent["enfant"+i]["enfant"].createEmptyMovieClip("enfant0", 0);
						prepareNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						break;
					default :
						//sera considéré comme texte
						ok = false;
					}
				} else {
					ok = false;
				}
			} else {
				ok = false;
			}
			if (!ok) {
				//c'est un texte ou considéré comme tel !
				parent.createEmptyMovieClip("enfant"+i, i);
				parent["enfant"+i].createEmptyMovieClip("enfant", 0);
				parent["enfant"+i]["enfant"].createTextField("texte", 0, 0, 0, 0, 5);
				parent["enfant"+i]["enfant"]["texte"].html = true;
				parent["enfant"+i]["enfant"]["texte"].autoSize = true;
				parent["enfant"+i]["enfant"]["texte"].selectable = false;
				parent["enfant"+i]["enfant"].ypos = 0;
			}
			parent["enfant"+i]["enfant"].ypos = 0;
			parent["enfant"+i]["enfant"].posbas = 0;
		}
	}
	//
	private function detruitNiveaux(tab : Array, parent : MovieClip) {
		//
		var ok : Boolean = true;
		var t : String = "";
		for (var i : Number = 0; i<tab.length; i++) {
			t = ""+tab[i];
			ok = (t.length != le_tableau[i].length);
			if (ok) {
				ok = (tab[i][0].indexOf(this.le_marqueur) == 0);
				if (ok) {
					var c : String = tab[i][0].substr(1);
					switch (c) {
					case "f" :
						detruitNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						detruitNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						parent["enfant"+i]["enfant"]["enfant1"].removeMovieClip();
						parent["enfant"+i]["enfant"]["enfant0"].removeMovieClip();
						parent["enfant"+i]["enfant"].removeMovieClip();
						parent["enfant"+i].removeMovieClip();
						break;
					case "a" :
					case "c" :
					case "e" :
					case "i" :
					case "p" :
					case "r" :
					case "u" :
					case "v" :
						prepareNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						parent["enfant"+i]["enfant"]["enfant0"].removeMovieClip();
						parent["enfant"+i]["enfant"].removeMovieClip();
						parent["enfant"+i].removeMovieClip();
						break;
					default :
						//sera considéré comme texte
						ok = false;
					}
				} else {
					ok = false;
				}
			} else {
				ok = false;
			}
			if (!ok) {
				//c'est un texte ou considéré comme tel !
				parent["enfant"+i]["enfant"]["texte"].removeTextField();
				parent["enfant"+i]["enfant"].removeMovieClip();
				parent["enfant"+i].removeMovieClip();
			}
		}
	}
	private function dessineNiveaux(tab : Array, parent : MovieClip) {
		//position horizontale des différents modules
		var xpos : Number = 0;
		//largeur max du numérateur ou dénominateur (fractions)
		var lmax : Number = 0;
		//position relative de la partie basse d'un module : bas d'un texte, trait de fraction ...
		//pour régler l'alignement vertical
		var posbas : Number = 0;
		//
		var ok : Boolean = true;
		var t : String = "";
		//
		for (var i : Number = 0; i<tab.length; i++) {
			//position horizontale des différents modules
			parent["enfant"+i]._x = xpos;
			// détecte si on a un texte ou un tableau !
			t = ""+tab[i];
			ok = (t.length != tab[i].length);
			if (ok) {
				//c'est un tableau,
				//détecte le marqueur en position 0
				ok = (tab[i][0].indexOf(this.le_marqueur) == 0);
				if (ok) {
					//marquer connu
					var c : String = tab[i][0].substr(1);
					switch (c) {
					case "a" :
						// *** ANGLE ***
						dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._y += 5;
						//parent["enfant"+i]["enfant"]["enfant0"].focusRect();
						//
						parent["enfant"+i]["enfant"].lineStyle(1, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(0, 5);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width/2, 1);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 5);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur-2;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+5);
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "c" :
						// *** CROCHETS ***
						dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._x += 2;
						parent["enfant"+i]["enfant"]["enfant0"]._y += 2;
						//
						parent["enfant"+i]["enfant"].lineStyle(1, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(5, 0);
						parent["enfant"+i]["enfant"].lineTo(0, 0);
						parent["enfant"+i]["enfant"].lineTo(0, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].lineTo(5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 0);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, 0);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						//
						parent["enfant"+i]["enfant"].ypos = (parent["enfant"+i]["enfant"]["enfant0"].hauteur+12)/2; //["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"]["enfant0"].hauteur+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+12);
						//
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "e" :
						// *** EXPOSANT ***
						dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						parent["enfant"+i]["enfant"]["enfant0"]._xscale = 75;
						parent["enfant"+i]["enfant"]["enfant0"]._yscale = 75;
						parent["enfant"+i]["enfant"]["enfant0"].hauteur *= 75/100;
						parent["enfant"+i]["enfant"]["enfant0"].taille *= 75/100;
						parent["enfant"+i]["enfant"]["enfant0"]._x-=2;
						//
						parent["enfant"+i]["enfant"]["enfant0"]._y = 0;
						//parent["enfant"+i]["enfant"]["enfant0"].focusRect();
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur; //+parent["enfant"+i]["enfant"]["enfant0"].taille;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+parent["enfant"+i]["enfant"]["enfant0"].taille*50/75+3);
						//
						xpos += parent["enfant"+i]["enfant"]._width-4;
						break;
					case "f" :
						// *** FRACTION ***
						dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						dessineNiveaux(tab[i][2], parent["enfant"+i]["enfant"]["enfant1"]);
						//
						lmax = Math.max(parent["enfant"+i]["enfant"]["enfant0"]._width, parent["enfant"+i]["enfant"]["enfant1"]._width);
						parent["enfant"+i]["enfant"]["enfant0"]._x = (lmax-parent["enfant"+i]["enfant"]["enfant0"]._width)/2;
						parent["enfant"+i]["enfant"]["enfant1"]._x = (lmax-parent["enfant"+i]["enfant"]["enfant1"]._width)/2;
						parent["enfant"+i]["enfant"]["enfant0"]._y = 0;
						parent["enfant"+i]["enfant"]["enfant1"]._y = parent["enfant"+i]["enfant"]["enfant0"].hauteur+4;
						//
						parent["enfant"+i]["enfant"].lineStyle(1, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(1, parent["enfant"+i]["enfant"]["enfant0"].hauteur+2);
						parent["enfant"+i]["enfant"].lineTo(lmax, parent["enfant"+i]["enfant"]["enfant0"].hauteur+2);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur+3;
						//
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+parent["enfant"+i]["enfant"]["enfant1"].hauteur+3);
						//
						xpos += lmax;
						break;
					case "i" :
						// *** INDICE ***
						dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						parent["enfant"+i]["enfant"]["enfant0"]._xscale = 75;
						parent["enfant"+i]["enfant"]["enfant0"]._yscale = 75;
						parent["enfant"+i]["enfant"]["enfant0"].hauteur *= 75/100;
						parent["enfant"+i]["enfant"]["enfant0"].taille *= 75/100;
						parent["enfant"+i]["enfant"]["enfant0"]._x-=2;
						//
						parent["enfant"+i]["enfant"]["enfant0"]._y = parent["enfant"+i]["enfant"]["enfant0"].taille*33/75;
						//parent["enfant"+i]["enfant"]["enfant0"].focusRect();
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"]._y+parent["enfant"+i]["enfant"]["enfant0"].taille*33/75;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+parent["enfant"+i]["enfant"]["enfant0"].taille*33/75+5);
						//
						xpos += parent["enfant"+i]["enfant"]._width-4;
						break;
					case "p" :
						// *** PARENTHESES ***
						dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._x += 2;
						parent["enfant"+i]["enfant"]["enfant0"]._y += 2;
						//
						parent["enfant"+i]["enfant"].lineStyle(1, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(5, 0);
						parent["enfant"+i]["enfant"].curveTo(0,0, 0,(parent["enfant"+i]["enfant"]["enfant0"].hauteur+2)/2);
						parent["enfant"+i]["enfant"].curveTo(0,(parent["enfant"+i]["enfant"]["enfant0"].hauteur+4), 5,parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 0);
						parent["enfant"+i]["enfant"].curveTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5,0, parent["enfant"+i]["enfant"]["enfant0"]._width+5,(parent["enfant"+i]["enfant"]["enfant0"].hauteur+2)/2);
						parent["enfant"+i]["enfant"].curveTo(parent["enfant"+i]["enfant"]["enfant0"]._width+5,(parent["enfant"+i]["enfant"]["enfant0"].hauteur+4), parent["enfant"+i]["enfant"]["enfant0"]._width,parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						//parent["enfant"+i]["enfant"].curveTo(-15,5,5, parent["enfant"+i]["enfant"]["enfant0"].hauteur+4);
						//
						parent["enfant"+i]["enfant"].ypos = (parent["enfant"+i]["enfant"]["enfant0"].hauteur+12)/2; //["enfant0"].hauteur-6;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"]["enfant0"].hauteur+6);
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+12);
						//
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "r" :
						// *** RACINE ***
						dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._x += 5;
						parent["enfant"+i]["enfant"]["enfant0"]._y += 2;
						//
						parent["enfant"+i]["enfant"].lineStyle(1, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(0, parent["enfant"+i]["enfant"]["enfant0"].hauteur*2/3);
						parent["enfant"+i]["enfant"].lineTo(2, parent["enfant"+i]["enfant"]["enfant0"].hauteur);
						parent["enfant"+i]["enfant"].lineTo(5, 0);
						parent["enfant"+i]["enfant"].lineTo(5+parent["enfant"+i]["enfant"]["enfant0"]._width, 0);
						//
						//parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur-6;
						//posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].posbas+1;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+2);
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "u" :
						// *** UNICODE ***
						var ltab : Array = [String.fromCharCode("0x"+tab[i][1])];
						dessineNiveaux( ltab, parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur);
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					case "v" :
						// *** VECTEUR ***
						dessineNiveaux(tab[i][1], parent["enfant"+i]["enfant"]["enfant0"]);
						//
						parent["enfant"+i]["enfant"]["enfant0"]._y += 5;
						//parent["enfant"+i]["enfant"]["enfant0"].focusRect();
						//
						parent["enfant"+i]["enfant"].lineStyle(1, this.la_couleur, 100);
						parent["enfant"+i]["enfant"].moveTo(0, 0);
						parent["enfant"+i]["enfant"].moveTo(0, 3);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 3);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width-3, 1);
						parent["enfant"+i]["enfant"].moveTo(parent["enfant"+i]["enfant"]["enfant0"]._width, 3);
						parent["enfant"+i]["enfant"].lineTo(parent["enfant"+i]["enfant"]["enfant0"]._width-3, 5);
						//
						parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["enfant0"].hauteur-2;
						posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
						//
						parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["enfant0"].hauteur+5);
						//
						xpos += parent["enfant"+i]["enfant"]._width;
						break;
					default :
						ok = false;
					}
				} else {
					ok = false;
				}
			} else {
				ok = false;
			}
			if (!ok) {
				//c'est un texte ou considéré comme tel !
				if (this.texteToHTMLFonc == undefined) {
					// -> texte brut
					parent["enfant"+i]["enfant"]["texte"].htmlText = tab[i];
				} else {
					// -> texte html mis en forme (codage TeP : 50+-:taille, +100:italique +200:gras +300:gras_italique
					parent["enfant"+i]["enfant"]["texte"].htmlText = texteToHTMLFonc(tab[i], this.la_taille_police, this.la_couleur, this.le_style);
				}
				parent["enfant"+i]["enfant"].ypos = parent["enfant"+i]["enfant"]["texte"]._height-8;
				posbas = Math.max(posbas, parent["enfant"+i]["enfant"].ypos);
				//
				xpos += parent["enfant"+i]._width;
				//parent["enfant"+i]["enfant"].focusRect();
				parent.hauteur = Math.max(parent.hauteur, parent["enfant"+i]["enfant"]["texte"]._height);
				//trace("hauteurs :"+tab[i]+" : "+parent.hauteur);
			} else {
				//trace("hauteurs :"+tab[i]+" : "+parent.hauteur+" - "+parent["enfant"+i]["enfant"]["enfant0"].hauteur);
			}
		}
		//trace("posbas ="+posbas);
		//
		//on aligne verticalement ...
		for (var i : Number = 0; i<tab.length; i++) {
			parent["enfant"+i]._y = posbas-parent["enfant"+i]["enfant"].ypos;
		}
		parent.posbas=posbas;
	}
}
